/*! FwMC-Storage - v2.4.3 - build date: 2015-02-19 10:53:59 */

"use strict";
var idbModules = {DEBUG: !1, DbTypes: {AUTO: "auto", WEBSQL: "WebSQL", INDEXEDDB: "IndexedDB"}, isIndexedDB: !1},
	cleanInterface = !1;
!function () {
	var testObject = {test: !0};
	if (Object.defineProperty) try {
		Object.defineProperty(testObject, "test", {enumerable: !1}), testObject.test && (cleanInterface = !0)
	} catch (e) {
	}
}(), function (idbModules) {
	function callback(fn, context, event, func) {
		event.target = context, "function" == typeof context[fn] && context[fn].apply(context, [event]), "function" == typeof func && func()
	}

	function throwDOMException(name, message, error) {
		var e;
		try {
			e = new DOMException.prototype.constructor(0, message)
		} catch (_error) {
			idbModules.DEBUG && console.warn("Error creating DOMException throwing Error instead"), e = new Error(message)
		}
		throw e.name = name, e.message = message, idbModules.DEBUG && (console.log(name, message, error, e), console.trace && console.trace()), e
	}

	var StringList = function () {
		this.length = 0, this._items = [], cleanInterface && Object.defineProperty(this, "_items", {enumerable: !1})
	};
	if (StringList.prototype = {
		contains: function (str) {
			return -1 !== this._items.indexOf(str)
		}, item: function (key) {
			return this._items[key]
		}, indexOf: function (str) {
			return this._items.indexOf(str)
		}, push: function (item) {
			this._items.push(item), this.length += 1;
			for (var i = 0; i < this._items.length; i++) this[i] = this._items[i]
		}, splice: function () {
			this._items.splice.apply(this._items, arguments), this.length = this._items.length;
			for (var i in this) i === String(parseInt(i, 10)) && delete this[i];
			for (i = 0; i < this._items.length; i++) this[i] = this._items[i]
		}
	}, cleanInterface) for (var i in{
		indexOf: !1,
		push: !1,
		splice: !1
	}) Object.defineProperty(StringList.prototype, i, {enumerable: !1});
	idbModules.util = {
		throwDOMException: throwDOMException, callback: callback, quote: function (arg) {
			return "'" + arg + "'"
		}, StringList: StringList
	}
}(idbModules), function (idbModules) {
	var Sca = function () {
		return {
			decycle: function (object, callback) {
				function checkForCompletion() {
					0 === queuedObjects.length && returnCallback(derezObj)
				}

				function readBlobAsDataURL(blob, path) {
					var reader = new FileReader;
					reader.onloadend = function (loadedEvent) {
						var dataURL = loadedEvent.target.result, blobtype = "blob";
						updateEncodedBlob(dataURL, path, blobtype)
					}, reader.readAsDataURL(blob)
				}

				function updateEncodedBlob(dataURL, path, blobtype) {
					var encoded = queuedObjects.indexOf(path);
					path = path.replace("$", "derezObj"), eval(path + '.$enc="' + dataURL + '"'), eval(path + '.$type="' + blobtype + '"'), queuedObjects.splice(encoded, 1), checkForCompletion()
				}

				function derez(value, path) {
					var i, name, nu;
					if (!("object" != typeof value || null === value || value instanceof Boolean || value instanceof Date || value instanceof Number || value instanceof RegExp || value instanceof Blob || value instanceof String)) {
						for (i = 0; i < objects.length; i += 1) if (objects[i] === value) return {$ref: paths[i]};
						if (objects.push(value), paths.push(path), "[object Array]" === Object.prototype.toString.apply(value)) for (nu = [], i = 0; i < value.length; i += 1) nu[i] = derez(value[i], path + "[" + i + "]"); else {
							nu = {};
							for (name in value) Object.prototype.hasOwnProperty.call(value, name) && (nu[name] = derez(value[name], path + "[" + JSON.stringify(name) + "]"))
						}
						return nu
					}
					return value instanceof Blob ? (queuedObjects.push(path), readBlobAsDataURL(value, path)) : value instanceof Boolean ? value = {
						$type: "bool",
						$enc: value.toString()
					} : value instanceof Date ? value = {
						$type: "date",
						$enc: value.getTime()
					} : value instanceof Number ? value = {
						$type: "num",
						$enc: value.toString()
					} : value instanceof RegExp && (value = {
						$type: "regex",
						$enc: value.toString()
					}), idbModules.DEBUG && console.log("[SHIM] derez : " + JSON.stringify(value)), value
				}

				var objects = [], paths = [], queuedObjects = [], returnCallback = callback,
					derezObj = derez(object, "$");
				checkForCompletion()
			}, retrocycle: function retrocycle($) {
				function dataURLToBlob(dataURL) {
					var contentType, parts, raw, BASE64_MARKER = ";base64,";
					if (-1 === dataURL.indexOf(BASE64_MARKER)) return parts = dataURL.split(","), contentType = parts[0].split(":")[1], raw = parts[1], new Blob([raw], {type: contentType});
					parts = dataURL.split(BASE64_MARKER), contentType = parts[0].split(":")[1], raw = window.atob(parts[1]);
					for (var rawLength = raw.length, uInt8Array = new Uint8Array(rawLength), i = 0; rawLength > i; ++i) uInt8Array[i] = raw.charCodeAt(i);
					return new Blob([uInt8Array.buffer], {type: contentType})
				}

				function rez(value) {
					idbModules.DEBUG && console.log("[SHIM] rez debut : " + JSON.stringify(value));
					var i, item, name, path;
					if (value && "object" == typeof value) if ("[object Array]" === Object.prototype.toString.apply(value)) for (i = 0; i < value.length; i += 1) item = value[i], item && "object" == typeof item && (path = item.$ref, value[i] = "string" == typeof path && px.test(path) ? eval(path) : rez(item)); else if (void 0 !== value.$type) switch (value.$type) {
						case"blob":
						case"file":
							value = dataURLToBlob(value.$enc);
							break;
						case"bool":
							value = Boolean("true" === value.$enc);
							break;
						case"date":
							value = new Date(value.$enc);
							break;
						case"num":
							value = Number(value.$enc);
							break;
						case"regex":
							value = eval(value.$enc)
					} else for (name in value) "object" == typeof value[name] && (item = value[name], item && (path = item.$ref, value[name] = "string" == typeof path && px.test(path) ? eval(path) : rez(item)));
					return idbModules.DEBUG && console.log("[SHIM] rez fin : " + value), value
				}

				var px = /^\$(?:\[(?:\d+|\"(?:[^\\\"\u0000-\u001f]|\\([\\\"\/bfnrt]|u[0-9a-zA-Z]{4}))*\")\])*$/;
				return rez($), $
			}, encode: function (val, callback) {
				function finishEncode(val) {
					callback(JSON.stringify(val))
				}

				this.decycle(val, finishEncode)
			}, decode: function (val) {
				return this.retrocycle(JSON.parse(val))
			}
		}
	}();
	idbModules.Sca = Sca
}(idbModules), function (idbModules) {
	var collations = ["", "number", "string", "boolean", "object", "undefined"], getGenericEncoder = function () {
		return {
			encode: function (key) {
				idbModules.DEBUG && console.log("[SHIM] getGenericEncoder.encode key : " + key);
				var r = collations.indexOf(typeof key) + "-" + JSON.stringify(key);
				return idbModules.DEBUG && console.log("[SHIM] getGenericEncoder.encode r : " + r), r
			}, decode: function (key) {
				idbModules.DEBUG && console.log("[SHIM] getGenericEncoder.decode key : " + key);
				var r;
				return r = "undefined" == typeof key ? void 0 : JSON.parse(key.substring(2)), idbModules.DEBUG && console.log("[SHIM] getGenericEncoder.decode r : " + r), r
			}
		}
	}, types = {
		number: getGenericEncoder("number"),
		"boolean": getGenericEncoder(),
		object: getGenericEncoder(),
		string: {
			encode: function (key) {
				return collations.indexOf("string") + "-" + key
			}, decode: function (key) {
				return "" + key.substring(2)
			}
		},
		undefined: {
			encode: function () {
				return collations.indexOf("undefined") + "-undefined"
			}, decode: function () {
				return void 0
			}
		}
	}, Key = function () {
		return {
			encode: function (key) {
				idbModules.DEBUG && console.log("[SHIM] Key.encode key : " + key);
				var r = types[typeof key].encode(key);
				return idbModules.DEBUG && console.log("[SHIM] Key.encode r : " + r), r
			}, decode: function (key) {
				idbModules.DEBUG && console.log("[SHIM] Key.decode key : " + key);
				var k = types[collations[key.substring(0, 1)]].decode(key);
				return idbModules.DEBUG && console.log("[SHIM] Key.decode return : " + k), k
			}
		}
	}();
	idbModules.Key = Key
}(idbModules), function (idbModules) {
	var Event = function (type, debug) {
		return idbModules.DEBUG && console.log("[SHIM] creation d un event type=" + type + " - debug=" + debug), {
			type: type,
			debug: debug,
			bubbles: !1,
			cancelable: !1,
			eventPhase: 0,
			timeStamp: new Date
		}
	};
	idbModules.Event = Event
}(idbModules), function (idbModules) {
	var IDBRequest = function () {
		idbModules.DEBUG && console.log("[SHIM] creation IDBRequest"), this.onsuccess = this.onerror = this.result = this.error = this.source = this.transaction = null, this.readyState = "pending"
	}, IDBOpenRequest = function () {
		idbModules.DEBUG && console.log("[SHIM] creation IDBOpenRequest"), this.onblocked = this.onupgradeneeded = null
	};
	IDBOpenRequest.prototype = IDBRequest, idbModules.IDBRequest = IDBRequest, idbModules.IDBOpenRequest = IDBOpenRequest
}(idbModules), function (idbModules, undefined) {
	var IDBKeyRange = function (lower, upper, lowerOpen, upperOpen) {
		idbModules.DEBUG && console.log("[SHIM] creation IDBKeyRange " + lower + " - " + upper + " - " + lowerOpen + " - " + upperOpen), this.lower = lower, this.upper = upper, this.lowerOpen = lowerOpen, this.upperOpen = upperOpen
	};
	IDBKeyRange.only = function (value) {
		return new IDBKeyRange(value, value, !1, !1)
	}, IDBKeyRange.lowerBound = function (value, open) {
		return new IDBKeyRange(value, undefined, open, undefined)
	}, IDBKeyRange.upperBound = function (value) {
		return new IDBKeyRange(undefined, value, undefined, open)
	}, IDBKeyRange.bound = function (lower, upper, lowerOpen, upperOpen) {
		return new IDBKeyRange(lower, upper, lowerOpen, upperOpen)
	}, idbModules.IDBKeyRange = IDBKeyRange
}(idbModules), function (idbModules, undefined) {
	function IDBCursor(range, direction, idbObjectStore, cursorRequest, keyColumnName, valueColumnName) {
		if (idbModules.DEBUG && (console.log("[SHIM] creation IDBCursor range " + range), console.log("[SHIM] creation IDBCursor direction " + direction), console.log("[SHIM] creation IDBCursor idbObjectStore " + idbObjectStore), console.log("[SHIM] creation IDBCursor cursorRequest " + cursorRequest), console.log("[SHIM] creation IDBCursor keyColumnName " + keyColumnName), console.log("[SHIM] creation IDBCursor valueColumnName " + valueColumnName)), !range || range instanceof idbModules.IDBKeyRange || (idbModules.DEBUG && console.log("[SHIM] creation IDBCursor range != IDBKeyRange => force creation de range"), range = new idbModules.IDBKeyRange(range, range, !1, !1)), this.__range = range, this.source = this.__idbObjectStore = idbObjectStore, this.__req = cursorRequest, this.key = undefined, this.direction = direction, this.__keyColumnName = keyColumnName, this.__valueColumnName = valueColumnName, this.__valueDecoder = "value" === valueColumnName ? idbModules.Sca : idbModules.Key, idbModules.DEBUG) {
			console.log("[SHIM] creation IDBCursor __keyColumnName " + this.__keyColumnName), console.log("[SHIM] creation IDBCursor __valueColumnName " + this.__valueColumnName);
			for (var i in idbObjectStore) console.log("function" == typeof idbObjectStore[i] ? "[SHIM] creation IDBCursor idbObjectStore[ " + i + "] = un function" : "[SHIM] creation IDBCursor idbObjectStore[ " + i + "] = " + idbObjectStore[i])
		}
		this.source.transaction.__active || idbModules.util.throwDOMException("TransactionInactiveError - The transaction this IDBObjectStore belongs to is not active."), this.__offset = -1, this.__lastKeyContinued = undefined, this["continue"]()
	}

	IDBCursor.prototype.__find = function (key, tx, success, error, recordsToLoad) {
		recordsToLoad = recordsToLoad || 1, idbModules.DEBUG && console.log("[SHIM] IDBCursor.__find recordToLoad : " + recordsToLoad);
		var me = this, sql = ["SELECT * FROM ", idbModules.util.quote(me.__idbObjectStore.name)], sqlValues = [];
		sql.push("WHERE ", me.__keyColumnName, " NOT NULL"), !me.__range || me.__range.lower === undefined && me.__range.upper === undefined || (sql.push("AND"), me.__range.lower !== undefined && (sql.push(me.__keyColumnName + (me.__range.lowerOpen ? " >" : " >= ") + " ?"), sqlValues.push(idbModules.Key.encode(me.__range.lower))), me.__range.lower !== undefined && me.__range.upper !== undefined && sql.push("AND"), me.__range.upper !== undefined && (sql.push(me.__keyColumnName + (me.__range.upperOpen ? " < " : " <= ") + " ?"), sqlValues.push(idbModules.Key.encode(me.__range.upper)))), "undefined" != typeof key && (me.__lastKeyContinued = key, me.__offset = 0), me.__lastKeyContinued !== undefined && (sql.push("AND " + me.__keyColumnName + " >= ?"), sqlValues.push(idbModules.Key.encode(me.__lastKeyContinued)));
		var direction = "prev" === me.direction || "prevunique" === me.direction ? "DESC" : "ASC";
		if (sql.push("ORDER BY ", me.__keyColumnName, " " + direction), sql.push("LIMIT " + recordsToLoad + " OFFSET " + me.__offset), idbModules.DEBUG) {
			console.log(sql.join(" "), sqlValues);
			for (var i in sqlValues) console.log(" sqlValues[" + i + "] = " + sqlValues[i])
		}
		me.__prefetchedData = null, tx.executeSql(sql.join(" "), sqlValues, function (tx, data) {
			data.rows.length > 1 ? (me.__prefetchedData = data.rows, me.__prefetchedIndex = 0, idbModules.DEBUG && console.log("Preloaded " + me.__prefetchedData.length + " records for cursor"), me.__decode(data.rows.item(0), success)) : 1 === data.rows.length ? me.__decode(data.rows.item(0), success) : (idbModules.DEBUG && console.log("Reached end of cursors"), success(undefined, undefined))
		}, function (tx, data) {
			idbModules.DEBUG && console.log("Could not execute Cursor.continue"), error(data)
		})
	}, IDBCursor.prototype.__decode = function (rowItem, callback) {
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.__decode " + this.__keyColumnName + " - " + this.__valueColumnName);
		var key = idbModules.Key.decode(rowItem[this.__keyColumnName]);
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.__decode  - key=" + key);
		var val = this.__valueDecoder.decode(rowItem[this.__valueColumnName]);
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.__decode  - val=" + val);
		var primaryKey = idbModules.Key.decode(rowItem.key);
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.__decode  - pk=" + primaryKey), callback(key, val, primaryKey)
	}, IDBCursor.prototype["continue"] = function (key) {
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.continue key=" + key);
		var recordsToPreloadOnContinue = idbModules.cursorPreloadPackSize || 100, me = this;
		this.__idbObjectStore.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__offset++;
			var successCallback = function (key, val, primaryKey) {
				me.key = key, me.value = val, me.primaryKey = primaryKey, success("undefined" != typeof me.key ? me : undefined, me.__req)
			};
			return me.__prefetchedData && (me.__prefetchedIndex++, me.__prefetchedIndex < me.__prefetchedData.length) ? void me.__decode(me.__prefetchedData.item(me.__prefetchedIndex), successCallback) : void me.__find(key, tx, successCallback, error, recordsToPreloadOnContinue)
		})
	}, IDBCursor.prototype.advance = function (count) {
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.advance : " + count), 0 >= count && idbModules.util.throwDOMException("Type Error - Count is invalid - 0 or negative", count);
		var me = this;
		this.__idbObjectStore.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__offset += count, me.__find(undefined, tx, function (key, value) {
				me.key = key, me.value = value, success("undefined" != typeof me.key ? me : undefined, me.__req)
			}, error)
		})
	}, IDBCursor.prototype.update = function (valueToUpdate) {
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.update v:" + valueToUpdate);
		var me = this, request = this.__idbObjectStore.transaction.__createRequest(function () {
		});
		return idbModules.Sca.encode(valueToUpdate, function (encoded) {
			me.__idbObjectStore.transaction.__pushToQueue(request, function (tx, args, success, error) {
				me.__find(undefined, tx, function (key, value, primaryKey) {
					var store = me.__idbObjectStore,
						storeProperties = me.__idbObjectStore.transaction.db.__storeProperties, params = [encoded],
						sql = "UPDATE " + idbModules.util.quote(store.name) + " SET value = ?",
						indexList = storeProperties[store.name] && storeProperties[store.name].indexList;
					if (indexList) for (var index in indexList) {
						var indexProps = indexList[index];
						sql += ", " + index + " = ?", params.push(idbModules.Key.encode(valueToUpdate[indexProps.keyPath]))
					}
					sql += " WHERE key = ?", params.push(idbModules.Key.encode(primaryKey)), idbModules.DEBUG && console.log(sql, encoded, key, primaryKey), tx.executeSql(sql, params, function (tx, data) {
						me.__prefetchedData = null, 1 === data.rowsAffected ? success(key) : error("No rows with key found" + key)
					}, function (tx, data) {
						error(data)
					})
				}, error)
			})
		}), request
	}, IDBCursor.prototype["delete"] = function () {
		idbModules.DEBUG && console.log("[SHIM] IDBCursor.delete");
		var me = this;
		return this.__idbObjectStore.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__find(undefined, tx, function (key, value, primaryKey) {
				var sql = "DELETE FROM  " + idbModules.util.quote(me.__idbObjectStore.name) + " WHERE key = ?";
				idbModules.DEBUG && console.log(sql, key, primaryKey), tx.executeSql(sql, [idbModules.Key.encode(primaryKey)], function (tx, data) {
					me.__prefetchedData = null, 1 === data.rowsAffected ? (me.__offset--, success(undefined)) : error("No rows with key found" + key)
				}, function (tx, data) {
					error(data)
				})
			}, error)
		})
	}, idbModules.IDBCursor = IDBCursor
}(idbModules), function (idbModules, undefined) {
	function IDBIndex(indexName, idbObjectStore) {
		idbModules.DEBUG && console.log("[SHIM] creation de IDBIndex " + indexName), this.indexName = this.name = indexName, this.__idbObjectStore = this.objectStore = this.source = idbObjectStore;
		var storeProps = idbObjectStore.transaction.db.__storeProperties[idbObjectStore.name],
			indexList = storeProps && storeProps.indexList;
		this.keyPath = indexList && indexList[indexName] && indexList[indexName].keyPath || indexName, ["multiEntry", "unique"].forEach(function (prop) {
			this[prop] = !!(indexList && indexList[indexName] && indexList[indexName].optionalParams && indexList[indexName].optionalParams[prop]), idbModules.DEBUG && console.log("[SHIM] creation de IDBIndex this[" + prop + "] = " + this[prop])
		}, this)
	}

	IDBIndex.prototype.__createIndex = function (indexName, keyPath, optionalParameters) {
		idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex " + indexName + " - " + keyPath);
		var me = this, transaction = me.__idbObjectStore.transaction;
		transaction.__addToTransactionQueue(function (tx, args, success, failure) {
			me.__idbObjectStore.__getStoreProps(tx, function () {
				function error() {
					idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex : Could not create new index  - " + arguments), idbModules.util.throwDOMException(0, "Could not create new index", arguments)
				}

				2 !== transaction.mode && (idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex : Invalid State error, not a version transaction"), idbModules.util.throwDOMException(0, "Invalid State error, not a version transaction", me.transaction));
				var idxList = JSON.parse(me.__idbObjectStore.__storeProps.indexList);
				"undefined" != typeof idxList[indexName] && (idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex : Index already exists on store"), idbModules.util.throwDOMException(0, "Index already exists on store", idxList));
				var columnName = indexName;
				idxList[indexName] = {
					columnName: columnName,
					keyPath: keyPath,
					optionalParams: optionalParameters
				}, me.__idbObjectStore.__storeProps.indexList = JSON.stringify(idxList);
				var sql = ["ALTER TABLE", idbModules.util.quote(me.__idbObjectStore.name), "ADD", columnName, "BLOB"].join(" ");
				idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex :" + sql), idbModules.DEBUG && console.log(sql), tx.executeSql(sql, [], function (tx, data) {
					idbModules.DEBUG && console.log("[SHIM] IDBIndex.__createIndex : SELECT * FROM " + idbModules.util.quote(me.__idbObjectStore.name)), tx.executeSql("SELECT * FROM " + idbModules.util.quote(me.__idbObjectStore.name), [], function (tx, data) {
						!function initIndexForRow(i) {
							if (i < data.rows.length) try {
								var value = idbModules.Sca.decode(data.rows.item(i).value),
									indexKey = eval("value['" + keyPath + "']");
								tx.executeSql("UPDATE " + idbModules.util.quote(me.__idbObjectStore.name) + " set " + columnName + " = ? where key = ?", [idbModules.Key.encode(indexKey), data.rows.item(i).key], function () {
									initIndexForRow(i + 1)
								}, error)
							} catch (e) {
								initIndexForRow(i + 1)
							} else {
								var sql = "CREATE ";
								optionalParameters && optionalParameters.unique ? (sql += "UNIQUE ", idbModules.DEBUG && console.log("Updating the indexes UNIQUE in table " + me.__idbObjectStore.__storeProps + " et " + indexName)) : (sql += " ", idbModules.DEBUG && console.log("Updating the indexes in table " + me.__idbObjectStore.__storeProps + " et " + indexName)), sql += "INDEX " + indexName + " ON " + me.__idbObjectStore.name + " (" + indexName + ")", idbModules.DEBUG && console.log("'[SHIM] IDBIndex.__createIndex : sql=" + sql), tx.executeSql(sql, [], function (tx) {
									idbModules.DEBUG && console.log("Updating the indexes in table", me.__idbObjectStore.__storeProps), tx.executeSql("UPDATE __sys__ set indexList = ? where name = ?", [me.__idbObjectStore.__storeProps.indexList, me.__idbObjectStore.name], function () {
										me.__idbObjectStore.__setReadyState(indexName, !0), success(me)
									}, error)
								}, error)
							}
						}(0)
					}, error)
				}, error)
			}, "createObjectStore")
		})
	}, IDBIndex.prototype.openCursor = function (range, direction) {
		idbModules.DEBUG && console.log("[SHIM] IDBIndex.openCursor");
		var cursorRequest = new idbModules.IDBRequest;
		idbModules.DEBUG && console.log("[SHIM] IDBIndex.openCursor new idbModules.IDBCursor indexName = " + this.indexName);
		new idbModules.IDBCursor(range, direction, this.source, cursorRequest, this.indexName, "value");
		return cursorRequest
	}, IDBIndex.prototype.openKeyCursor = function (range, direction) {
		idbModules.DEBUG && console.log("[SHIM] IDBIndex.openKeyCursor");
		{
			var cursorRequest = new idbModules.IDBRequest;
			new idbModules.IDBCursor(range, direction, this.source, cursorRequest, this.indexName, "key")
		}
		return cursorRequest
	}, IDBIndex.prototype.__fetchIndexData = function (key, opType) {
		idbModules.DEBUG && console.log("[SHIM] IDBIndex.__fetchIndexData");
		var me = this;
		return me.__idbObjectStore.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			var sql = ["SELECT * FROM ", idbModules.util.quote(me.__idbObjectStore.name), " WHERE", me.indexName, "NOT NULL"],
				sqlValues = [];
			"undefined" != typeof key && (sql.push("AND", me.indexName, " = ?"), sqlValues.push(idbModules.Key.encode(key))), idbModules.DEBUG && console.log("Trying to fetch data for Index", sql.join(" "), sqlValues), tx.executeSql(sql.join(" "), sqlValues, function (tx, data) {
				var d;
				d = "count" === opType ? data.rows.length : 0 === data.rows.length ? undefined : "key" === opType ? idbModules.Key.decode(data.rows.item(0).key) : idbModules.Sca.decode(data.rows.item(0).value), success(d)
			}, error)
		})
	}, IDBIndex.prototype.get = function (key) {
		return idbModules.DEBUG && console.log("[SHIM] IDBIndex.get"), this.__fetchIndexData(key, "value")
	}, IDBIndex.prototype.getKey = function (key) {
		return idbModules.DEBUG && console.log("[SHIM] IDBIndex.getKey"), this.__fetchIndexData(key, "key")
	}, IDBIndex.prototype.count = function (key) {
		return idbModules.DEBUG && console.log("[SHIM] IDBIndex.count"), this.__fetchIndexData(key, "count")
	}, idbModules.IDBIndex = IDBIndex
}(idbModules), function (idbModules) {
	var IDBObjectStore = function (name, idbTransaction, ready) {
		idbModules.DEBUG && console.log("[SHIM] creation IDBObjectStore " + name), this.name = name, this.transaction = idbTransaction, this.__ready = {}, this.__setReadyState("createObjectStore", "undefined" == typeof ready ? !0 : ready), this.indexNames = new idbModules.util.StringList;
		var dbProps = idbTransaction.db.__storeProperties;
		if (dbProps[name] && dbProps[name].indexList) {
			idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.IDBObjectStore " + name + " indexList ok ");
			var indexes = dbProps[name].indexList;
			for (var indexName in indexes) idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.IDBObjectStore  index : " + indexName), indexes.hasOwnProperty(indexName) && (idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.IDBObjectStore  push index : " + indexName), this.indexNames.push(indexName))
		}
	};
	IDBObjectStore.prototype.__setReadyState = function (key, val) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__setReadyState " + key + " - " + val), this.__ready[key] = val
	}, IDBObjectStore.prototype.__waitForReady = function (callback, key) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__waitForReady ");
		var ready = !0;
		if ("undefined" != typeof key) ready = "undefined" == typeof this.__ready[key] ? !0 : this.__ready[key]; else for (var x in this.__ready) this.__ready[x] || (ready = !1);
		if (ready) callback(); else {
			idbModules.DEBUG && console.log("Waiting for to be ready", key, this.__ready);
			var me = this;
			window.setTimeout(function () {
				me.__waitForReady(callback, key)
			}, 100)
		}
	}, IDBObjectStore.prototype.__getStoreProps = function (tx, callback) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__getStoreProps ");
		var me = this;
		me.__storeProps ? (idbModules.DEBUG && console.log("Store properties - cached", me.__storeProps), callback(me.__storeProps)) : tx.executeSql("SELECT * FROM __sys__ where name = ?", [me.name], function (tx, data) {
			1 !== data.rows.length ? callback() : (me.__storeProps = {
				name: data.rows.item(0).name,
				indexList: data.rows.item(0).indexList,
				autoInc: data.rows.item(0).autoInc,
				keyPath: data.rows.item(0).keyPath
			}, idbModules.DEBUG && console.log("Store properties", me.__storeProps), callback(me.__storeProps))
		}, function () {
			callback()
		})
	}, IDBObjectStore.prototype.__deriveKey = function (tx, value, key, callback) {
		function getNextAutoIncKey() {
			idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__deriveKey getNextAutoIncKey : SELECT * FROM sqlite_sequence where name like " + me.name), tx.executeSql("SELECT * FROM sqlite_sequence where name like ?", [me.name], function (tx, data) {
				1 !== data.rows.length ? (idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__deriveKey : callback(0)"), callback(0)) : (idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__deriveKey : callback(" + data.rows.item(0).seq + ")"), callback(data.rows.item(0).seq))
			}, function (tx, error) {
				idbModules.util.throwDOMException(0, "Data Error - Could not get the auto increment value for key", error)
			})
		}

		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__deriveKey ");
		var me = this;
		me.__getStoreProps(tx, function (props) {
			if (props || idbModules.util.throwDOMException(0, "Data Error - Could not locate defination for this table", props), props.keyPath) if ("undefined" != typeof key && idbModules.util.throwDOMException(0, "Data Error - The object store uses in-line keys and the key parameter was provided", props), value) try {
				var primaryKey = eval("value['" + props.keyPath + "']");
				void 0 === primaryKey ? "true" === props.autoInc ? getNextAutoIncKey() : idbModules.util.throwDOMException(0, "Data Error - Could not eval key from keyPath") : callback(primaryKey)
			} catch (e) {
				idbModules.util.throwDOMException(0, "Data Error - Could not eval key from keyPath", e)
			} else idbModules.util.throwDOMException(0, "Data Error - KeyPath was specified, but value was not"); else "undefined" != typeof key ? callback(key) : "false" === props.autoInc ? idbModules.util.throwDOMException(0, "Data Error - The object store uses out-of-line keys and has no key generator and the key parameter was not provided. ", props) : getNextAutoIncKey()
		})
	}, IDBObjectStore.prototype.__insertData = function (tx, encoded, value, primaryKey, success, error) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData "), idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData encoded=" + encoded), idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData value" + value), idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData pk" + primaryKey);
		var paramMap = {};
		"undefined" != typeof primaryKey && (paramMap.key = idbModules.Key.encode(primaryKey));
		var indexes = JSON.parse(this.__storeProps.indexList), myObject = value;
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData this.__storeProps.indexList=" + this.__storeProps.indexList), idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData indexes=" + indexes);
		for (var key in indexes) {
			idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData key=" + key);
			try {
				for (var fields = indexes[key].keyPath.toString().split(","), fValue = "", i = 0; i < fields.length; i++) "" != fValue && (fValue += ","), fValue += myObject[fields[i]];
				paramMap[indexes[key].columnName] = idbModules.Key.encode(fValue)
			} catch (e) {
				idbModules.DEBUG && console.log("ERROR =>" + e + " et " + key), error(e)
			}
		}
		var sqlStart = ["INSERT INTO ", idbModules.util.quote(this.name), "("], sqlEnd = [" VALUES ("], sqlValues = [];
		for (key in paramMap) sqlStart.push(key + ","), sqlEnd.push("?,"), sqlValues.push(paramMap[key]);
		sqlStart.push("value )"), sqlEnd.push("?)"), sqlValues.push(encoded);
		var sql = sqlStart.join(" ") + sqlEnd.join(" ");
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.__insertData sql=" + sql), idbModules.DEBUG && console.log("SQL for adding", sql, sqlValues), tx.executeSql(sql, sqlValues, function () {
			success(primaryKey)
		}, function (tx, err) {
			error(err)
		})
	}, IDBObjectStore.prototype.add = function (value, key) {
		idbModules.DEBUG && (console.log("[SHIM] IDBObjectStore.add "), console.log("[SHIM] IDBObjectStore.add value:" + value), console.log("[SHIM] IDBObjectStore.add key:" + key));
		var me = this, request = me.transaction.__createRequest(function () {
		});
		return idbModules.Sca.encode(value, function (encoded) {
			me.__waitForReady(function () {
				me.transaction.__pushToQueue(request, function (tx, args, success, error) {
					me.__deriveKey(tx, value, key, function (primaryKey) {
						me.__insertData(tx, encoded, value, primaryKey, success, error)
					})
				})
			})
		}), request
	}, IDBObjectStore.prototype.put = function (value, key) {
		idbModules.DEBUG && (console.log("[SHIM] IDBObjectStore.put "), console.log("[SHIM] IDBObjectStore.put value:" + value), console.log("[SHIM] IDBObjectStore.put key:" + key));
		var me = this, request = me.transaction.__createRequest(function () {
		});
		return idbModules.Sca.encode(value, function (encoded) {
			me.__waitForReady(function () {
				me.transaction.__pushToQueue(request, function (tx, args, success, error) {
					me.__deriveKey(tx, value, key, function (primaryKey) {
						var sql = "DELETE FROM " + idbModules.util.quote(me.name) + " where key = ?";
						tx.executeSql(sql, [idbModules.Key.encode(primaryKey)], function (tx, data) {
							idbModules.DEBUG && console.log("Did the row with the", primaryKey, "exist? ", data.rowsAffected), me.__insertData(tx, encoded, value, primaryKey, success, error)
						}, function (tx, err) {
							error(err)
						})
					})
				})
			})
		}), request
	}, IDBObjectStore.prototype.get = function (key) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.get ");
		var me = this;
		return me.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__waitForReady(function () {
				var primaryKey = idbModules.Key.encode(key);
				idbModules.DEBUG && console.log("Fetching", me.name, primaryKey), tx.executeSql("SELECT * FROM " + idbModules.util.quote(me.name) + " where key = ?", [primaryKey], function (tx, data) {
					idbModules.DEBUG && console.log("Fetched data", data);
					try {
						if (0 === data.rows.length) return success();
						success(idbModules.Sca.decode(data.rows.item(0).value))
					} catch (e) {
						idbModules.DEBUG && console.log(e), success(void 0)
					}
				}, function (tx, err) {
					error(err)
				})
			})
		})
	}, IDBObjectStore.prototype["delete"] = function (key) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.delete ");
		var me = this;
		return me.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__waitForReady(function () {
				var primaryKey = idbModules.Key.encode(key);
				idbModules.DEBUG && console.log("Fetching", me.name, primaryKey), tx.executeSql("DELETE FROM " + idbModules.util.quote(me.name) + " where key = ?", [primaryKey], function (tx, data) {
					idbModules.DEBUG && console.log("Deleted from database", data.rowsAffected), success()
				}, function (tx, err) {
					error(err)
				})
			})
		})
	}, IDBObjectStore.prototype.clear = function () {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.clear ");
		var me = this;
		return me.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__waitForReady(function () {
				tx.executeSql("DELETE FROM " + idbModules.util.quote(me.name), [], function (tx, data) {
					idbModules.DEBUG && console.log("Cleared all records from database", data.rowsAffected), success()
				}, function (tx, err) {
					error(err)
				})
			})
		})
	}, IDBObjectStore.prototype.count = function (key) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.count ");
		var me = this;
		return me.transaction.__addToTransactionQueue(function (tx, args, success, error) {
			me.__waitForReady(function () {
				var sql = "SELECT * FROM " + idbModules.util.quote(me.name) + ("undefined" != typeof key ? " WHERE key = ?" : ""),
					sqlValues = [];
				"undefined" != typeof key && sqlValues.push(idbModules.Key.encode(key)), tx.executeSql(sql, sqlValues, function (tx, data) {
					success(data.rows.length)
				}, function (tx, err) {
					error(err)
				})
			})
		})
	}, IDBObjectStore.prototype.openCursor = function (range, direction) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.openCursor ");
		{
			var cursorRequest = new idbModules.IDBRequest;
			new idbModules.IDBCursor(range, direction, this, cursorRequest, "key", "value")
		}
		return cursorRequest
	}, IDBObjectStore.prototype.index = function (indexName) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.index ");
		var index = new idbModules.IDBIndex(indexName, this);
		return index
	}, IDBObjectStore.prototype.createIndex = function (indexName, keyPath, optionalParameters) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.createIndex ");
		var me = this;
		optionalParameters = optionalParameters || {}, me.__setReadyState(indexName, !1);
		var result = new idbModules.IDBIndex(indexName, me);
		me.__waitForReady(function () {
			result.__createIndex(indexName, keyPath, optionalParameters)
		}, "createObjectStore"), me.indexNames.push(indexName);
		var storeProps = me.transaction.db.__storeProperties[me.name];
		return storeProps.indexList[indexName] = {keyPath: keyPath, optionalParams: optionalParameters}, result
	}, IDBObjectStore.prototype.deleteIndex = function (indexName) {
		idbModules.DEBUG && console.log("[SHIM] IDBObjectStore.deleteIndex ");
		var result = new idbModules.IDBIndex(indexName, this, !1);
		return result.__deleteIndex(indexName), result
	}, idbModules.IDBObjectStore = IDBObjectStore
}(idbModules), function (idbModules) {
	var READ = 0, READ_WRITE = 1, VERSION_TRANSACTION = 2, IDBTransaction = function (storeNames, mode, db) {
		if (idbModules.DEBUG && console.log("[SHIM] creation IDBTransaction " + storeNames + "," + mode + "," + db), "number" == typeof mode) this.mode = mode, 2 !== mode && idbModules.DEBUG && console.log("Mode should be a string, but was specified as ", mode); else if ("string" == typeof mode) switch (mode) {
			case"readwrite":
				this.mode = READ_WRITE;
				break;
			case"readonly":
				this.mode = READ;
				break;
			default:
				this.mode = READ
		}
		this.storeNames = "string" == typeof storeNames ? [storeNames] : storeNames;
		for (var i = 0; i < this.storeNames.length; i++) db.objectStoreNames.contains(this.storeNames[i]) || idbModules.util.throwDOMException(0, "The operation failed because the requested database object could not be found. For example, an object store did not exist but was being opened.", this.storeNames[i]);
		this.__active = !0, this.__running = !1, this.__requests = [], this.__aborted = !1, this.db = db, this.error = null, this.onabort = this.onerror = this.oncomplete = null
	};
	IDBTransaction.prototype.__executeRequests = function () {
		if (idbModules.DEBUG && console.log("[SHIM] IDBTransaction__executeRequests "), this.__running && this.mode !== VERSION_TRANSACTION) return void(idbModules.DEBUG && console.log("Looks like the request set is already running", this.mode));
		this.__running = !0;
		var me = this;
		window.setTimeout(function () {
			2 === me.mode || me.__active || idbModules.util.throwDOMException(0, "A request was placed against a transaction which is currently not active, or which is finished", me.__active), me.db.__db.transaction(function (tx) {
				function success(result, req) {
					req && (q.req = req), q.req.readyState = "done", q.req.result = result, delete q.req.error;
					var e = idbModules.Event("success");
					idbModules.util.callback("onsuccess", q.req, e), i++, executeRequest()
				}

				function error(errorVal) {
					q.req.readyState = "done", q.req.error = errorVal;
					var e = idbModules.Event("error", arguments);
					idbModules.util.callback("onerror", q.req, e), i++, executeRequest()
				}

				function executeRequest() {
					return i >= me.__requests.length ? (me.__active = !1, void(me.__requests = [])) : (q = me.__requests[i], void q.op(tx, q.args, success, error))
				}

				me.__tx = tx;
				var q = null, i = 0;
				try {
					executeRequest()
				} catch (e) {
					idbModules.DEBUG && console.log("An exception occured in transaction", arguments), "function" == typeof me.onerror && me.onerror()
				}
			}, function () {
				idbModules.DEBUG && console.log("An error in transaction", arguments), "function" == typeof me.onerror && me.onerror()
			}, function () {
				idbModules.DEBUG && console.log("Transaction completed", arguments), "function" == typeof me.oncomplete && me.oncomplete()
			})
		}, 1)
	}, IDBTransaction.prototype.__addToTransactionQueue = function (callback, args) {
		idbModules.DEBUG && console.log("[SHIM] IDBTransaction.__addToTransactionQueue "), this.__active || this.mode === VERSION_TRANSACTION || idbModules.util.throwDOMException(0, "A request was placed against a transaction which is currently not active, or which is finished.", this.__mode);
		var request = this.__createRequest();
		return this.__pushToQueue(request, callback, args), request
	}, IDBTransaction.prototype.__createRequest = function () {
		idbModules.DEBUG && console.log("[SHIM] IDBTransaction.__createRequest ");
		var request = new idbModules.IDBRequest;
		return request.source = this.db, request.transaction = this, request
	}, IDBTransaction.prototype.__pushToQueue = function (request, callback, args) {
		idbModules.DEBUG && console.log("[SHIM] IDBTransaction.__pushToQueue "), this.__requests.push({
			op: callback,
			args: args,
			req: request
		}), this.__executeRequests()
	}, IDBTransaction.prototype.objectStore = function (objectStoreName) {
		return idbModules.DEBUG && console.log("[SHIM] IDBTransaction.objectStore "), new idbModules.IDBObjectStore(objectStoreName, this)
	}, IDBTransaction.prototype.abort = function () {
		idbModules.DEBUG && console.log("[SHIM] IDBTransaction.abort "), !this.__active && idbModules.util.throwDOMException(0, "A request was placed against a transaction which is currently not active, or which is finished", this.__active)
	}, IDBTransaction.prototype.READ_ONLY = 0, IDBTransaction.prototype.READ_WRITE = 1, IDBTransaction.prototype.VERSION_CHANGE = 2, idbModules.IDBTransaction = IDBTransaction
}(idbModules), function (idbModules) {
	var IDBDatabase = function (db, name, version, storeProperties) {
		idbModules.DEBUG && console.log("[SHIM] creation IDBDatabase"), this.__db = db, this.version = version, this.objectStoreNames = new idbModules.util.StringList;
		for (var i = 0; i < storeProperties.rows.length; i++) this.objectStoreNames.push(storeProperties.rows.item(i).name);
		for (this.__storeProperties = {}, i = 0; i < storeProperties.rows.length; i++) {
			var row = storeProperties.rows.item(i), objectStoreProps = this.__storeProperties[row.name] = {};
			objectStoreProps.keyPath = row.keypath, objectStoreProps.autoInc = "true" === row.autoInc, objectStoreProps.indexList = JSON.parse(row.indexList), idbModules.DEBUG && console.log("[SHIM] creation IDBDatabase - __storeProperties " + row.name + " - " + row.keypath)
		}
		this.name = name, this.onabort = this.onerror = this.onversionchange = null
	};
	IDBDatabase.prototype.createObjectStore = function (storeName, createOptions) {
		idbModules.DEBUG && console.log("[SHIM] IDBDatabase.createObjectStore");
		var me = this;
		createOptions = createOptions || {}, createOptions.keyPath = createOptions.keyPath || null;
		var result = new idbModules.IDBObjectStore(storeName, me.__versionTransaction, !1),
			transaction = me.__versionTransaction;
		transaction.__addToTransactionQueue(function (tx, args, success) {
			function error() {
				idbModules.util.throwDOMException(0, "Could not create new object store", arguments)
			}

			me.__versionTransaction || idbModules.util.throwDOMException(0, "Invalid State error", me.transaction);
			var sql = ["CREATE TABLE", idbModules.util.quote(storeName), "(key BLOB", createOptions.autoIncrement ? ", inc INTEGER PRIMARY KEY AUTOINCREMENT" : "PRIMARY KEY", ", value BLOB)"].join(" ");
			idbModules.DEBUG && console.log(sql), tx.executeSql(sql, [], function (tx) {
				tx.executeSql("INSERT INTO __sys__ VALUES (?,?,?,?)", [storeName, createOptions.keyPath, createOptions.autoIncrement ? !0 : !1, "{}"], function () {
					result.__setReadyState("createObjectStore", !0), success(result)
				}, error)
			}, error)
		}), me.objectStoreNames.push(storeName);
		var storeProps = me.__storeProperties[storeName] = {};
		return storeProps.keyPath = createOptions.keyPath, storeProps.autoInc = !!createOptions.autoIncrement, storeProps.indexList = {}, result
	}, IDBDatabase.prototype.deleteObjectStore = function (storeName) {
		idbModules.DEBUG && console.log("[SHIM] IDBDatabase.deleteObjectStore");
		var error = function () {
			idbModules.util.throwDOMException(0, "Could not delete ObjectStore", arguments)
		}, me = this;
		!me.objectStoreNames.contains(storeName) && error("Object Store does not exist"), me.objectStoreNames.splice(me.objectStoreNames.indexOf(storeName), 1);
		var transaction = me.__versionTransaction;
		transaction.__addToTransactionQueue(function () {
			me.__versionTransaction || idbModules.util.throwDOMException(0, "Invalid State error", me.transaction), me.__db.transaction(function (tx) {
				tx.executeSql("SELECT * FROM __sys__ where name = ?", [storeName], function (tx, data) {
					data.rows.length > 0 && tx.executeSql("DROP TABLE " + idbModules.util.quote(storeName), [], function () {
						tx.executeSql("DELETE FROM __sys__ WHERE name = ?", [storeName], function () {
						}, error)
					}, error)
				})
			})
		})
	}, IDBDatabase.prototype.close = function () {
	}, IDBDatabase.prototype.transaction = function (storeNames, mode) {
		idbModules.DEBUG && console.log("[SHIM] IDBDatabase.transaction");
		var transaction = new idbModules.IDBTransaction(storeNames, mode || 1, this);
		return transaction
	}, idbModules.IDBDatabase = IDBDatabase
}(idbModules);
var initShimDB = function (idbModules, options) {
	var def = Q.defer(), DEFAULT_DB_SIZE = 4194304, dbType = idbModules.DbTypes.AUTO;
	if ("undefined" != typeof options && options && options.forceDbType && (dbType = options.forceDbType), dbType === idbModules.DbTypes.WEBSQL) {
		if ("undefined" == typeof window.openDatabase) return console.error("DbType forcé à WebSQL mais WebSQL n'est pas disponible sur cette plateforme !"), def.reject(new Error("DbType forcé à WebSQL mais WebSQL n'est pas disponible sur cette plateforme !")), def.promise;
		idbModules.DEBUG && console.log("[SHIM] WebSQL va être utilisé")
	} else {
		if (dbType === idbModules.DbTypes.INDEXEDDB) return "undefined" == typeof window.indexedDB ? (console.error("DbType forcé à IndexedDB mais IndexedDB n'est pas disponible sur cette plateforme !"), def.reject(new Error("DbType forcé à IndexedDB mais IndexedDB n'est pas disponible sur cette plateforme !")), def.promise) : (idbModules.DEBUG && console.log("[SHIM] IndexedDB va être utilisé"), idbModules.shimIndexedDB = window.indexedDB, idbModules.IDBDatabase = window.IDBDatabase, idbModules.IDBTransaction = window.IDBTransaction, idbModules.IDBCursor = window.IDBCursor, idbModules.IDBKeyRange = window.IDBKeyRange, def.resolve(), idbModules.isIndexedDB = !0, def.promise);
		if ("undefined" == typeof window.openDatabase) return "undefined" == typeof window.indexedDB ? (console.error("WebSQL et IndexedDB ne sont pas disponibles - IndexedDbShim non utilisable sur cette plateforme !"), def.reject(new Error("WebSQL et IndexedDB ne sont pas disponibles - IndexedDbShim non utilisable sur cette plateforme !")), def.promise) : (idbModules.DEBUG && console.log("[SHIM] IndexedDB va être utilisé"), idbModules.shimIndexedDB = window.indexedDB, idbModules.IDBDatabase = window.IDBDatabase, idbModules.IDBTransaction = window.IDBTransaction, idbModules.IDBCursor = window.IDBCursor, idbModules.IDBKeyRange = window.IDBKeyRange, def.resolve(), idbModules.isIndexedDB = !0, def.promise);
		idbModules.DEBUG && console.log("[SHIM] WebSQL va être utilisé")
	}
	idbModules.DEBUG && console.log('[SHIM] window.openDatabase "__sysdb__", 1, "System Database", DEFAULT_DB_SIZE');
	var sysdb = window.openDatabase("__sysdb__", 1, "System Database", DEFAULT_DB_SIZE);
	sysdb.transaction(function (tx) {
		idbModules.DEBUG && console.log('[SHIM] tx.executeSql("SELECT * FROM dbVersions"'), tx.executeSql("SELECT * FROM dbVersions", [], function () {
			idbModules.DEBUG && console.log("[SHIM] dbVersions already exists"), def.resolve()
		}, function () {
			idbModules.DEBUG && console.log("[SHIM] dbVersions does not exist, so creating it"), sysdb.transaction(function (tx) {
				idbModules.DEBUG && console.log('[SHIM] tx.executeSql("CREATE TABLE IF NOT EXISTS dbVersions (name VARCHAR(255), version INT);"'), tx.executeSql("CREATE TABLE IF NOT EXISTS dbVersions (name VARCHAR(255), version INT);", [], function () {
					idbModules.DEBUG && console.log("[SHIM] ok table dbVersions"), def.resolve()
				}, function (e) {
					idbModules.DEBUG && console.log("[SHIM] ERREUR Could not create table __sysdb__ to save DB versions : " + e), def.reject(e), idbModules.util.throwDOMException("Could not create table __sysdb__ to save DB versions")
				})
			})
		})
	}, function (e) {
		idbModules.DEBUG && console.log("[SHIM] sysdb.transaction KO : " + e), def.reject(e), idbModules.DEBUG && console.log("Error in sysdb transaction - when selecting from dbVersions", arguments)
	});
	var shimIndexedDB = {
		open: function (name, version) {
			function dbCreateError() {
				if (idbModules.DEBUG) {
					console.log("[SHIM] shimIndexedDB open dbCreateError : " + e);
					for (var i in e) console.log("[SHIM] shimIndexedDB open dbCreateError : e[" + i + "]=" + e[i])
				}
				if (!calledDbCreateError) {
					var e = idbModules.Event("error", arguments);
					req.readyState = "done", req.error = "DOMError", idbModules.util.callback("onerror", req, e), calledDbCreateError = !0
				}
			}

			function openDB(oldVersion) {
				idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open openDB");
				var db = window.openDatabase(name, 1, name, DEFAULT_DB_SIZE);
				req.readyState = "done", "undefined" == typeof version && (version = oldVersion || 1), (0 >= version || oldVersion > version) && idbModules.util.throwDOMException(0, "An attempt was made to open a database using a lower version than the existing version.", version), db.transaction(function (tx) {
					idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open openDB transaction"), tx.executeSql("CREATE TABLE IF NOT EXISTS __sys__ (name VARCHAR(255), keyPath VARCHAR(255), autoInc BOOLEAN, indexList BLOB)", [], function () {
						tx.executeSql("SELECT * FROM __sys__", [], function (tx, data) {
							var e = idbModules.Event("success");
							req.source = req.result = new idbModules.IDBDatabase(db, name, version, data), version > oldVersion ? sysdb.transaction(function (systx) {
								systx.executeSql("UPDATE dbVersions set version = ? where name = ?", [version, name], function () {
									var e = idbModules.Event("upgradeneeded");
									e.oldVersion = oldVersion, e.newVersion = version, req.transaction = req.result.__versionTransaction = new idbModules.IDBTransaction([], 2, req.source), idbModules.util.callback("onupgradeneeded", req, e, function () {
										var e = idbModules.Event("success");
										idbModules.util.callback("onsuccess", req, e)
									})
								}, dbCreateError)
							}, dbCreateError) : idbModules.util.callback("onsuccess", req, e)
						}, dbCreateError)
					}, dbCreateError)
				}, dbCreateError)
			}

			idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open");
			var req = new idbModules.IDBOpenRequest;
			idbModules.DEBUG && console.log("[SHIM] shimIndexedDB new req");
			var calledDbCreateError = !1;
			return sysdb.transaction(function (tx) {
				idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open sysdb.transaction"), tx.executeSql("SELECT * FROM dbVersions where name = ?", [name], function (tx, data) {
					idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open executeSql"), 0 === data.rows.length ? (idbModules.DEBUG && console.log("[SHIM] shimIndexedDB open Database with this name does not exist"), tx.executeSql("INSERT INTO dbVersions VALUES (?,?)", [name, version || 1], function () {
						openDB(0)
					}, dbCreateError)) : openDB(data.rows.item(0).version)
				}, dbCreateError)
			}, dbCreateError), req
		}, deleteDatabase: function (name) {
			function dbError(msg) {
				if (!calledDBError) {
					req.readyState = "done", req.error = "DOMError";
					var e = idbModules.Event("error");
					e.message = msg, e.debug = arguments, idbModules.util.callback("onerror", req, e), calledDBError = !0
				}
			}

			function deleteFromDbVersions() {
				sysdb.transaction(function (systx) {
					systx.executeSql("DELETE FROM dbVersions where name = ? ", [name], function () {
						req.result = void 0;
						var e = idbModules.Event("success");
						e.newVersion = null, e.oldVersion = version, idbModules.util.callback("onsuccess", req, e)
					}, dbError)
				}, dbError)
			}

			var req = new idbModules.IDBOpenRequest, calledDBError = !1, version = null;
			return sysdb.transaction(function (systx) {
				systx.executeSql("SELECT * FROM dbVersions where name = ?", [name], function (tx, data) {
					if (0 === data.rows.length) {
						req.result = void 0;
						var e = idbModules.Event("success");
						return e.newVersion = null, e.oldVersion = version, void idbModules.util.callback("onsuccess", req, e)
					}
					version = data.rows.item(0).version;
					var db = window.openDatabase(name, 1, name, DEFAULT_DB_SIZE);
					db.transaction(function (tx) {
						tx.executeSql("SELECT * FROM __sys__", [], function (tx, data) {
							var tables = data.rows;
							!function deleteTables(i) {
								i >= tables.length ? tx.executeSql("DROP TABLE __sys__", [], function () {
									deleteFromDbVersions()
								}, dbError) : tx.executeSql("DROP TABLE " + idbModules.util.quote(tables.item(i).name), [], function () {
									deleteTables(i + 1)
								}, function () {
									deleteTables(i + 1)
								})
							}(0)
						}, function () {
							deleteFromDbVersions()
						})
					}, dbError)
				})
			}, dbError), req
		}, cmp: function (key1, key2) {
			return idbModules.Key.encode(key1) > idbModules.Key.encode(key2) ? 1 : key1 === key2 ? 0 : -1
		}
	};
	if (idbModules.shimIndexedDB = shimIndexedDB, idbModules.DEBUG && console.log("[SHIM] fin creation idbModules.shimIndexedDB ..."), window.shimIndexedDB = idbModules.shimIndexedDB, window.shimIndexedDB) {
		idbModules.DEBUG && console.log("[SHIM] création window.shimIndexedDB.__useShim"), window.shimIndexedDB.__useShim = function () {
			idbModules.DEBUG && console.log("[SHIM] init de Shim"), window.indexedDB = idbModules.shimIndexedDB, window.IDBDatabase = idbModules.IDBDatabase, window.IDBTransaction = idbModules.IDBTransaction, window.IDBCursor = idbModules.IDBCursor, window.IDBKeyRange = idbModules.IDBKeyRange, window.indexedDB && window.indexedDB === window.shimIndexedDB ? idbModules.DEBUG && console.log("[SHIM] test ok de Shim window.indexedDB === window.shimIndexedDB") : idbModules.DEBUG && console.log("[SHIM] test KO de Shim window.indexedDB === window.shimIndexedDB"), window.indexedDB && window.indexedDB === idbModules.shimIndexedDB ? idbModules.DEBUG && console.log("[SHIM] test ok de Shim window.indexedDB === idbModules.shimIndexedDB") : idbModules.DEBUG && console.log("[SHIM] test KO de Shim window.indexedDB === idbModules.shimIndexedDB"), window.shimIndexedDB && window.shimIndexedDB === idbModules.shimIndexedDB ? idbModules.DEBUG && console.log("[SHIM] test ok de Shim window.shimIndexedDB === idbModules.shimIndexedDB") : idbModules.DEBUG && console.log("[SHIM] test KO de Shim window.shimIndexedDB === idbModules.shimIndexedDB"), idbModules.DEBUG && console.log("[SHIM] fin init de Shim")
		}, window.shimIndexedDB.__debug = function (val) {
			idbModules.DEBUG = val
		}, "indexedDB" in window || (window.indexedDB = window.indexedDB || window.webkitIndexedDB || window.mozIndexedDB || window.oIndexedDB || window.msIndexedDB);
		var poorIndexedDbSupport = !1;
		if ((navigator.userAgent.match(/Android 2/) || navigator.userAgent.match(/Android 3/) || navigator.userAgent.match(/Android 4\.[0-3]/)) && (navigator.userAgent.match(/Chrome/) || (poorIndexedDbSupport = !0)), "undefined" != typeof window.indexedDB && !poorIndexedDbSupport || "undefined" == typeof window.openDatabase) {
			window.IDBDatabase = window.IDBDatabase || window.webkitIDBDatabase, window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction, window.IDBCursor = window.IDBCursor || window.webkitIDBCursor, window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange, window.IDBTransaction || (window.IDBTransaction = {});
			try {
				window.IDBTransaction.READ_ONLY = window.IDBTransaction.READ_ONLY || "readonly", window.IDBTransaction.READ_WRITE = window.IDBTransaction.READ_WRITE || "readwrite"
			} catch (e) {
			}
		} else window.shimIndexedDB.__useShim()
	}
	return def.promise
};
var FwMC = FwMC || {};
FwMC.Properties = FwMC.Properties || {}, FwMC.Properties.Storage = {
	_version_FwMC_Storage: "2.4.3",
	DbTypes: {AUTO: idbModules.DbTypes.AUTO, WEBSQL: idbModules.DbTypes.WEBSQL, INDEXEDDB: idbModules.DbTypes.INDEXEDDB}
};
FwMC.Storage = {
	backupDataBase: function () {
		var a = Q.defer();
		return a.reject("FwMC.Storage.backupDataBase() n'est pas surchargée"), a.promise
	}, restoreDataBase: function () {
		var a = Q.defer();
		return a.reject("FwMC.Storage.restoreDataBase() n'est pas surchargée"), a.promise
	}
}, FwMC.Storage._Dao = FwMC.Class.extend({
	constructor: function (a) {
		FwMC.Core._Debug.log("_Dao - construteur avec id=" + a), this._resourceId = a
	}, getResourceId: {
		value: function () {
			return FwMC.Core._Debug.log("_Dao - getResourceId : " + this._resourceId), this._resourceId
		}, writable: !0, enumerable: !0
	}, setPrimaryKey: {
		value: function (a) {
			FwMC.Core._Debug.log("_Dao - setPrimaryKey : " + a), this._pKey = a
		}, writable: !0, enumerable: !0
	}, getPrimaryKey: {
		value: function () {
			return FwMC.Core._Debug.log("_Dao - getPrimaryKey : " + this._pKey), this._pKey
		}, writable: !0, enumerable: !0
	}, setNaturalKey: {
		value: function (a) {
			FwMC.Core._Debug.log("_Dao - setNaturalKey : " + a), this._naturalKey = a
		}, writable: !1, enumerable: !0
	}, getNaturalKey: {
		value: function () {
			return FwMC.Core._Debug.log("_Dao - getNaturalKey : " + this._naturalKey), this._naturalKey
		}, writable: !1, enumerable: !0
	}
}), FwMC.Storage.PersistentObject = FwMC.Class.extend({
	LocalStorage: {value: 0, configurable: !1, writable: !1, enumerable: !0},
	RemoteStorage: {value: 1, configurable: !1, writable: !1, enumerable: !0},
	AutoStorage: {value: 2, configurable: !1, writable: !1, enumerable: !0},
	constructor: function (a) {
		if (void 0 === a) throw FwMC.Core._Debug.error("descriptor obligatoire !"), new Error("descriptor obligatoire !");
		if (!(a instanceof FwMC.Storage.PersistentObjectDescriptor)) throw FwMC.Core._Debug.error("descriptor non valide, il doit être un FwMC.Storage.PersistentObjectDescriptor !"), new Error("wrong type : FwMC.Storage.PersistentObjectDescriptor expected !");
		this._desc = a, this._doConfig(a)
	},
	_doConfig: function (a) {
		FwMC.Core._Debug.log("PersistentObject._doConfig - initialisation"), this._inner_dao = new Array;
		var b = FwMC.Storage.RemoteDaoFactory._getDao(a);
		if (this._inner_dao[this.RemoteStorage] = b, a.store) {
			var c = FwMC.Storage.LocalDaoFactory._getDao(a);
			this._inner_dao[this.LocalStorage] = c
		}
	},
	doInsert: {
		value: function (a, b) {
			var c = !1;
			switch ("undefined" != typeof b && (c = b), FwMC.Core._Debug.log("PersistentObject.doInsert - mode=" + a + " fc=" + c), a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage].doInsert(this);
				case this.RemoteStorage:
					return this._inner_dao[this.RemoteStorage].doInsert(this, c);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !0
	},
	doUpdate: {
		value: function (a) {
			switch (FwMC.Core._Debug.log("PersistentObject.doUpdate - mode=" + a), a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage].doUpdate(this);
				case this.RemoteStorage:
					return this._inner_dao[this.RemoteStorage].doUpdate(this);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !0
	},
	doGet: {
		value: function (a) {
			switch (FwMC.Core._Debug.log("PersistentObject.doGet - mode=" + a), a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage].doGet(this);
				case this.RemoteStorage:
					return this._inner_dao[this.RemoteStorage].doGet(this);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !0
	},
	doGetList: {
		value: function (a, b, c, d, e) {
			var f = this._desc;
			if (FwMC.Core._Debug.log("PersistentObject.doGetList - mode=" + a + " index=" + c + "desc=" + b + " value=" + d + " option=" + e), void 0 === this._desc || null == this._desc) {
				if (FwMC.Core._Debug.log("PersistentObject.doGetList - utilisation en static"), void 0 === b || null == b) throw new Error("doGetList en mode STATIC : Descriptor obligatoire");
				this._doConfig(b), f = b
			} else FwMC.Core._Debug.log("PersistentObject.doGetList - utilisation en instance");
			switch (a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage].doGetList(this, c, d, f);
				case this.RemoteStorage:
					return void 0 !== c && null != c ? this._inner_dao[this.RemoteStorage].doGetList(this, f.mapIndex[c].keypath, d, e, f) : this._inner_dao[this.RemoteStorage].doGetList(this, null, null, e, f);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !0
	},
	doDelete: {
		value: function (a) {
			switch (FwMC.Core._Debug.log("PersistentObject.doDelete - mode=" + a), a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage].doDelete(this);
				case this.RemoteStorage:
					return this._inner_dao[this.RemoteStorage].doDelete(this);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !0
	},
	doClear: {
		value: function (a) {
			if (FwMC.Core._Debug.log("PersistentObject.doClear "), void 0 === this._desc || null == this._desc) {
				if (FwMC.Core._Debug.log("PersistentObject.doClear - utilisation en static"), void 0 === a || null == a) throw new Error("doClear en mode STATIC : Descriptor obligatoire");
				this._doConfig(a)
			} else FwMC.Core._Debug.log("PersistentObject.doClear - utilisation en instance");
			return this._inner_dao[this.LocalStorage].doClear(this)
		}, writable: !1, enumerable: !0
	},
	doReplaceAll: {
		value: function (a, b, c) {
			if (FwMC.Core._Debug.log("PersistentObject.doReplaceAll - mode=" + a), void 0 === this._desc || null == this._desc) {
				if (FwMC.Core._Debug.log("PersistentObject.doReplaceAll - utilisation en static"), void 0 === c || null == c) throw new Error("doReplaceAll en mode STATIC : Descriptor obligatoire");
				this._doConfig(c)
			} else FwMC.Core._Debug.log("PersistentObject.doReplaceAll - utilisation en instance"), this._doConfig(this._desc);
			switch (a) {
				case this.LocalStorage:
					return this._inner_dao[this.LocalStorage]._doReplaceAll(this, b);
				default:
					throw new Error("Mode inconnu ou non géré!")
			}
		}, writable: !1, enumerable: !1
	},
	isAttributPersistent: {
		value: function (a) {
			return "_inner_dao" != a && "_desc" != a
		}, writable: !0, enumerable: !1
	},
	toDTO: {
		value: function () {
			var a = {}, b = this;
			return Object.getOwnPropertyNames(this).forEach(function (c) {
				b.isAttributPersistent(c) && (a[c] = b[c])
			}), a
		}, writable: !1, enumerable: !1
	},
	toDTODistant: {
		value: function () {
			return this.toDTO()
		}, writable: !0, enumerable: !0
	},
	populateFromDTO: {
		value: function (a, b) {
			var c = this;
			Object.getOwnPropertyNames(a).forEach(function (b) {
				c[b] = a[b]
			}), this._desc.autoIncrement === !0 && void 0 !== b && (this[this._desc.getPrimaryKey()] = b)
		}, writable: !1, enumerable: !1
	}
}), FwMC.Storage.PersistentObjectDescriptor = FwMC.Class.extend({
	constructor: function (a, b, c) {
		if (void 0 === b) throw FwMC.Core._Debug.error("uri obligatoire !"), new Error("uri obligatoire !");
		if (void 0 === a) throw FwMC.Core._Debug.error("resourceId obligatoire !"), new Error("resourceId obligatoire !");
		this.resourceId = a, this.uri = b, this.store = c, this.mapIndex = {}, this.ajaxParams = {
			dataType: "json",
			timeout: FwMC.Core.getDefaultTimeout()
		}, this.pkey = a + "_PK", this.autoIncrement = !0
	}, setAutoIncrement: function (a) {
		this.autoIncrement = a
	}, isAutoIncrement: function () {
		return this.autoIncrement
	}, setPrimaryKey: function (a) {
		this.pkey = a
	}, getPrimaryKey: function () {
		return this.pkey
	}, setNaturalKey: function (a) {
		this.naturalKey = a
	}, getNaturalKey: function () {
		return this.naturalKey
	}, addIndex: function (a, b, c) {
		this.mapIndex[a] = {id: a, keypath: b, unique: c}
	}, getIndex: function (a) {
		return this.mapIndex[a]
	}, getAllIndexes: function () {
		return this.mapIndex
	}, setFormat: function (a) {
		this.ajaxParams.dataType = a
	}, getFormat: function () {
		return this.ajaxParams.dataType
	}, setTimeout: function (a) {
		this.ajaxParams.timeout = a
	}, getTimeout: function () {
		return this.ajaxParams.timeout
	}, setAjaxParams: function (a) {
		this.ajaxParams = a
	}, getAjaxParams: function () {
		return this.ajaxParams
	}
}), FwMC.Storage.PersistentObjectLocalFactory = {
	dbDescriptorMap: {},
	datastoreMap: {},
	addPersistentObjectDescriptor: function (a) {
		var b = a.store || "FwMC_Default_IndexedDB", c = 1;
		a.version && (c = parseInt(a.version)), FwMC.Core._Debug.log("PersistentObjectLocalFactory - addPersistentObjectDescriptor : " + b + " en " + c);
		var d = this.dbDescriptorMap[b];
		void 0 === d && (d = {
			name: b,
			version: c,
			objectStoreNames: new Array,
			objectStoreDescriptorMap: {},
			addObjectStoreDesc: function (a, b, c, d) {
				FwMC.Core._Debug.log("PersistentObjectLocalFactory - addObjectStoreDesc : " + a + " / " + b + " / " + d), this.objectStoreNames.push(a), this.objectStoreDescriptorMap[a] = {
					name: a,
					pkDescriptor: {keyPath: b, autoIncrement: c},
					indexMap: d
				}
			}
		}), d.addObjectStoreDesc(a.resourceId, a.pkey, a.autoIncrement, a.getAllIndexes()), this.dbDescriptorMap[b] = d
	},
	initLocalFactory: function (a) {
		FwMC.Core._Debug.log("PersistentObjectLocalFactory - initLocalFactory "), this.datastoreMap = {};
		var b = this, c = initShimDB(idbModules, a).then(function () {
			FwMC.Core._Debug.log("PersistentObjectLocalFactory - initLocalFactory - init SHIM OK"), FwMC.Storage.indexedDB = idbModules.shimIndexedDB, FwMC.Storage.IDBDatabase = idbModules.IDBDatabase, FwMC.Storage.IDBTransaction = idbModules.IDBTransaction, FwMC.Storage.IDBCursor = idbModules.IDBCursor, FwMC.Storage.IDBKeyRange = idbModules.IDBKeyRange;
			var a = [];
			return Object.getOwnPropertyNames(b.dbDescriptorMap).forEach(function (c) {
				a.push(b._openDB(b.dbDescriptorMap[c]))
			}), Q.all(a)
		}, function (a) {
			FwMC.Core._Debug.log("PersistentObjectLocalFactory - initLocalFactory - init SHIM KO : " + a.message)
		});
		return c
	},
	resetLocalFactory: function () {
		this.datastoreMap = {};
		var a = this;
		Object.getOwnPropertyNames(this.datastoreMap).forEach(function (b) {
			a.datastoreMap[b] = null
		}), a.datastoreMap = {}, Object.getOwnPropertyNames(this.dbDescriptorMap).forEach(function (b) {
			a.dbDescriptorMap[b] = null
		}), a.dbDescriptorMap = {}
	},
	_openDB: function (a) {
		var b = Q.defer(), c = this;
		FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB : " + a.name + " v" + a.version);
		var d = function (a) {
			if (FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - name : " + a.name), FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - version : " + a.version), FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - nb objectstore : " + a.objectStoreNames.length), a.objectStoreNames.length > 0) for (var b = 0; b < a.objectStoreNames.length; b++) FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - objectstore : " + a.objectStoreNames[b])
		}, e = function (a, b) {
			var c, d = Q.defer();
			b.objectStoreNames.forEach(function (d) {
				FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - création de l'objectStore : " + d);
				var e = b.objectStoreDescriptorMap[d];
				c = a.createObjectStore(e.name, e.pkDescriptor), Object.getOwnPropertyNames(e.indexMap).forEach(function (a) {
					FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - création de l'index avec id= " + a + ", keyPath : " + e.indexMap[a].keypath + " , unique : " + e.indexMap[a].unique), c.createIndex(a, e.indexMap[a].keypath, {unique: e.indexMap[a].unique}), FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - création de l'index ok : " + a)
				}), FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - création de l'objectStore : OK")
			});
			var e = c.transaction;
			return e.oncomplete = function () {
				d.resolve()
			}, e.onerror = function () {
				d.reject(e.error)
			}, d.promise
		}, f = function (b, c) {
			var d = Q.defer(), f = FwMC.Storage.indexedDB.open(b, c);
			return f.onerror = function (a) {
				FwMC.Core._Debug.error("PersistentObjectLocalFactory - _openDB - openCreateRequest.onerror : " + a.target.error.message), d.reject(a.target.error)
			}, f.onupgradeneeded = function (b) {
				FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - openCreateRequest.onupgradeneeded");
				var c = b.target.result;
				e(c, a).then(function () {
					d.resolve(c)
				}, function (a) {
					d.reject(a)
				}).done()
			}, f.onsuccess = function (a) {
				FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - openCreateRequest.onsuccess");
				var b = a.target.result;
				d.resolve(b)
			}, d.promise
		}, g = FwMC.Storage.indexedDB.open(a.name);
		return g.onerror = function (a) {
			FwMC.Core._Debug.error("PersistentObjectLocalFactory - _openDB - openDbRequest.onerror : " + a.target.error.message), b.reject(a.target.error)
		}, g.onupgradeneeded = function (b) {
			FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - openDbRequest.onupgradeneeded");
			var c = b.target.result;
			1 === a.version && 1 === c.version && e(c, a)
		}, g.onsuccess = function (e) {
			FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - openDbRequest.onsuccess");
			var g = e.target.result;
			if (g.version >= a.version) g.version > a.version && (console.error("La base " + g.name + " est en version " + g.version + " et vous demandez une version inférieur (" + a.version + ") !!!"), console.log("La version " + g.version + " va être retournée"), c.dbDescriptorMap[a.name].version = g.version), d(g), c.datastoreMap[g.name] = g, FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - fin : " + g.name), b.resolve(g); else {
				c.datastoreMap[g.name] = g;
				var h = g.version;
				FwMC.Storage.backupDataBase(g.name, h).then(function (e) {
					g.close();
					var i = FwMC.Storage.indexedDB.deleteDatabase(a.name);
					i.onerror = function (c) {
						FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - Erreur sur deleteDatabase : " + a.name + " version " + h), b.reject(c.target.error)
					}, i.onsuccess = function () {
						FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - deleteDatabase OK"), f(a.name, a.version).then(function (a) {
							delete c.datastoreMap[a.name], c.datastoreMap[a.name] = a, FwMC.Storage.restoreDataBase(a.name, e).then(function () {
								d(a), FwMC.Core._Debug.log("PersistentObjectLocalFactory - _openDB - fin : " + a.name), b.resolve(a)
							}).done()
						}).done()
					}
				}).fail(function (a) {
					b.reject(a)
				}).done()
			}
		}, b.promise
	},
	getDatastore: function (a) {
		return this.datastoreMap[a]
	},
	deleteDatastore: function (a) {
		var b = this, c = Q.defer(), d = this.datastoreMap[a];
		d && d.close();
		var e = FwMC.Storage.indexedDB.deleteDatabase(a);
		return e.onerror = function (a) {
			c.reject(a.target.error)
		}, e.onsuccess = function () {
			delete b.datastoreMap[a], c.resolve()
		}, c.promise
	}
};
FwMC.Storage._DaoIndexedDB = FwMC.Storage._Dao.extend({
	constructor: function (a, b) {
		FwMC.Storage._DaoIndexedDB._super.constructor.call(this, b), this.storeName = a, FwMC.Core._Debug.log("_DaoIndexedDB - construteur avec store=" + this.storeName)
	}, _makeReponse: function (a, b, c) {
		return 0 == a ? {code: a, ref: b, result: c[0]} : {code: a, ref: b, result: {name: c[0], message: c[1]}}
	}, _processError: function (a, b, c) {
		var d;
		if (a.target.error) a.target.error.code ? (FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror error.code: " + a.target.error.code), FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror error.message: " + a.target.error.message), d = this._makeReponse(-1, b, [a.target.error.code, a.target.error.message])) : a.target.error.name ? (FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror error.name: " + a.target.error.name), FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror error.message: " + a.target.error.message), d = this._makeReponse(-1, b, [a.target.error.name, a.target.error.message])) : (FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror : error " + a.target.error), d = this._makeReponse(-1, b, [a.target.error, a.target.error])); else if (a.target.errorCode) {
			var e = a.target.errorMessage || a.target.webkitErrorMessage;
			e ? (FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror ErrorMessage: " + e), d = this._makeReponse(-1, b, [a.target.errorCode, e])) : (FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror errorCode: " + a.target.errorCode), derror = this._makeReponse(-1, b, [a.target.errorCode, "Erreur Message non disponible"]))
		} else FwMC.Core._Debug.error("_DaoIndexedDB - " + c + " - onerror : e.target.error non présent !?"), d = this._makeReponse(-1, b, ["ERR", "Erreur inconnue"]);
		return d
	}, _getDatastore: function () {
		FwMC.Core._Debug.log("_DaoIndexedDB - getDatastore ");
		var a = FwMC.Storage.PersistentObjectLocalFactory.getDatastore(this.storeName);
		if (a) return FwMC.Core._Debug.log("_DaoIndexedDB - getDatastore : utilisation du datastore existant" + a), a;
		throw FwMC.Core._Debug.error("_DaoIndexedDB - getDatastore : datastore non initialisé ! " + this.storeName), new Error("datastore non initialisé ! " + this.storeName)
	}, _getStore: function (a, b) {
		FwMC.Core._Debug.log("_DaoIndexedDB - getStore ");
		var b = b || FwMC.Storage.IDBTransaction.READ_WRITE || "readwrite";
		FwMC.Core._Debug.log("_DaoIndexedDB - datastore.transaction(" + this.getResourceId() + ", " + b + "); ");
		var c = a.transaction([this.getResourceId()], b);
		FwMC.Core._Debug.log("_DaoIndexedDB - transaction : " + c), FwMC.Core._Debug.log("_DaoIndexedDB - transaction.objectStore(" + this.getResourceId() + "); ");
		var d = c.objectStore(this.getResourceId());
		return FwMC.Core._Debug.log("_DaoIndexedDB - getStore récupération de " + d), d
	}, _makePromiseObjectStore: function (a) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseObjectStore ");
		var b = this, c = Q(b._getDatastore()), d = c.then(function (c) {
			return b._getStore(c, a)
		});
		return d
	}, _makePromiseInsert: function (a, b) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseInsert : " + a);
		var c = this, d = b.toDTO(), e = Q.defer();
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseInsert - dto : " + d);
		var f = a.add(d);
		return f.onsuccess = function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseInsert - onsuccess : id " + a.target.result), b[c.getPrimaryKey()] = a.target.result, e.resolve(c._makeReponse(0, b, [b]))
		}, f.onerror = function (a) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseInsert - onerror "), e.reject(c._processError(a, b, "_makePromiseInsert"))
		}, e.promise
	}, doInsert: {
		value: function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doInsert");
			var b = this;
			if (a._desc.autoIncrement === !1 || "" === a[b.getPrimaryKey()] || null === a[b.getPrimaryKey()] || void 0 === a[b.getPrimaryKey()]) {
				var c = this._makePromiseObjectStore(), d = c.then(function (c) {
					return b._makePromiseInsert(c, a)
				});
				return FwMC.Core._Debug.log("_DaoIndexedDB - doInsert return : " + d.inspect()), d
			}
			return Q.reject(b._processError({
				target: {
					error: {
						name: "CONSTRAINT_ERR",
						message: "Primary Key en auto-increment, forcage de valeur interdit"
					}
				}
			}, a, "doInsert"))
		}, writable: !1, enumerable: !0
	}, _makePromiseUpdate: function (a, b) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseUpdate ");
		var c = b.toDTO(), d = b[this.getPrimaryKey()], e = this, f = Q.defer();
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseUpdate - id : " + d);
		var g = a.get(d);
		return g.onsuccess = function (d) {
			if (d.target.result) {
				FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseUpdate - Ok object déjà présent");
				var g = a.put(c);
				g.onsuccess = function (a) {
					FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseUpdate - onsuccess :  " + a.target.result), f.resolve(e._makeReponse(0, b, [b]))
				}, g.onerror = function (a) {
					FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseUpdate - onerror "), f.reject(e._processError(a, b, "_makePromiseUpdate"))
				}
			} else FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseUpdate - Object à modifier inexistant en base !"), f.reject(e._makeReponse(-1, b, ["incoherent", "Object à modifier inexistant en base !"]))
		}, g.onerror = function (a) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseUpdate - onerror objet non trouvé : " + a.target.error.message), f.reject(e._makeReponse(-1, b, [a.target.error.name, a.target.error.message]))
		}, f.promise
	}, doUpdate: {
		value: function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doUpdate");
			var b = this, c = this._makePromiseObjectStore(), d = c.then(function (c) {
				return b._makePromiseUpdate(c, a)
			});
			return FwMC.Core._Debug.log("_DaoIndexedDB - doUpdate return : " + d.inspect()), d
		}, writable: !1, enumerable: !0
	}, _makePromiseGet: function (a, b, c) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGet ");
		var d = Q.defer(), e = this;
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGet - id : " + c);
		var f = b.get(c);
		return f.onsuccess = function (b) {
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGet - onsuccess :  " + b.target.result), b.target.result ? (a.populateFromDTO(b.target.result, c), d.resolve(e._makeReponse(0, a, [a]))) : d.resolve(e._makeReponse(0, a, [null]))
		}, f.onerror = function (b) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseGet - onerror "), d.reject(e._processError(b, a, "_makePromiseGet"))
		}, d.promise
	}, doGet: {
		value: function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doGet");
			var b = this, c = a[this.getPrimaryKey()], d = this._makePromiseObjectStore("readonly"),
				e = d.then(function (d) {
					return b._makePromiseGet(a, d, c)
				});
			return FwMC.Core._Debug.log("_DaoIndexedDB - doGet return : " + e.inspect()), e
		}, writable: !1, enumerable: !0
	}, _makePromiseGetList: function (a, b, c, d, e) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList ");
		var f = a._desc || e, g = Q.defer(), h = this;
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList - index : " + c + " value : " + d);
		var i;
		if (void 0 !== c && null != c && "" !== c) {
			var j = b.index(c);
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList - recup de l index OK : " + j), i = void 0 === d ? j.openCursor() : j.openCursor(d instanceof Array && !idbModules.isIndexedDB ? FwMC.Storage.IDBKeyRange.only(d.join()) : FwMC.Storage.IDBKeyRange.only(d))
		} else i = b.openCursor(), FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList - recup de request sur objectStore : ");
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList - request OK : " + i);
		var k = new Array;
		return i.onsuccess = function (b) {
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseGetList - onsuccess :  ");
			var c = b.target.result;
			if (c) {
				var d = new a.constructor(f);
				d.populateFromDTO(c.value, c.primaryKey), k.push(d), c.__proto__["continue"].apply(c)
			} else g.resolve(h._makeReponse(0, a, [k]))
		}, i.onerror = function (b) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseGetList - onerror "), g.reject(h._processError(b, a, "_makePromiseGetList"))
		}, g.promise
	}, doGetList: {
		value: function (a, b, c, d) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doGetList");
			var e = this, f = this._makePromiseObjectStore("readonly"), g = f.then(function (f) {
				return e._makePromiseGetList(a, f, b, c, d)
			});
			return FwMC.Core._Debug.log("_DaoIndexedDB - doGetList return : " + g.inspect()), g
		}, writable: !1, enumerable: !0
	}, _makePromiseDelete: function (a, b, c) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseDelete ");
		var d = Q.defer(), e = this;
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseDelete - id : " + c);
		var f = b.__proto__["delete"].apply(b, [c]);
		return f.onsuccess = function (b) {
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseDelete - onsuccess :  " + b.target.result), d.resolve(e._makeReponse(0, a, [null]))
		}, f.onerror = function (b) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseDelete - onerror "), d.reject(e._processError(b, a, "_makePromiseDelete"))
		}, d.promise
	}, doDelete: {
		value: function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doDelete");
			var b = this, c = a[this.getPrimaryKey()], d = this._makePromiseObjectStore(), e = d.then(function (d) {
				return b._makePromiseDelete(a, d, c)
			});
			return e
		}, writable: !1, enumerable: !0
	}, _makePromiseClear: function (a, b) {
		FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseClear ");
		var c = Q.defer(), d = this, e = b.clear();
		return e.onsuccess = function (b) {
			FwMC.Core._Debug.log("_DaoIndexedDB - _makePromiseClear - onsuccess :  " + b.target.result), c.resolve(d._makeReponse(0, a, [null]))
		}, e.onerror = function (b) {
			FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseClear - onerror"), c.reject(d._processError(b, a, "_makePromiseClear"))
		}, c.promise
	}, doClear: {
		value: function (a) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doClear");
			var b = this, c = this._makePromiseObjectStore(), d = c.then(function (c) {
				return b._makePromiseClear(a, c)
			});
			return d
		}, writable: !1, enumerable: !0
	}, _doReplaceAll: {
		value: function (a, b) {
			FwMC.Core._Debug.log("_DaoIndexedDB - doReplaceAll");
			var c = this;
			return this._makePromiseObjectStore().then(function (d) {
				var e = Q.defer(), f = d.clear();
				return f.onsuccess = function (f) {
					FwMC.Core._Debug.log("_DaoIndexedDB - _doReplaceAll - clear - onsuccess : " + f.target);
					var g = [];
					b.forEach(function (b) {
						var f = Q.defer(), h = {};
						try {
							h = d.add(b)
						} catch (i) {
							FwMC.Core._Debug.error("_DaoIndexedDB - _doReplaceAll - add - exception " + b + i.stack), f.reject(c._makeReponse(-1, b, ["_doReplaceAll add " + i.message, i.stack])), e.reject(c._makeReponse(-1, b, ["_doReplaceAll add " + i.message, i.stack]))
						}
						h.onsuccess = function (b) {
							FwMC.Core._Debug.log("_DaoIndexedDB - _doReplaceAll - add - onsuccess : id " + b.target.result), f.resolve(c._makeReponse(0, a, [a]))
						}, h.onerror = function (b) {
							FwMC.Core._Debug.error("_DaoIndexedDB - _doReplaceAll - add - onerror " + a), f.reject(c._processError(b, a, "_doReplaceAll add")), e.reject(c._processError(b, a, "_doReplaceAll add"))
						}, g.push(function () {
							return f.promise
						})
					}), g.reduce(Q.when, Q()).then(function () {
						FwMC.Core._Debug.log("_DaoIndexedDB - _doReplaceAll - onsuccess : FIN " + a), e.resolve(c._makeReponse(0, a, [null]))
					}).done()
				}, f.onerror = function (a) {
					FwMC.Core._Debug.error("_DaoIndexedDB - _makePromiseClear - onerror "), e.reject(c._processError(a, dto, "_doReplaceAll clear"))
				}, e.promise
			})
		}, writable: !1, enumerable: !1
	}
});
FwMC.Storage.DaoRemote = FwMC.Storage._Dao.extend({
	constructor: function (a, b) {
		FwMC.Storage.DaoRemote._super.constructor.call(this, b), this.uri = a, this.ajaxParams = {dataType: "json"}, FwMC.Core._Debug.log("DaoRemote - construteur avec uri=" + a)
	}, getIdFromLocation: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getIdFromLocation : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, getInsertUrlPart: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getInsertUrlPart : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, getUpdateUrlPart: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getUpdateUrlPart : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, getDeleteUrlPart: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getDeleteUrlPart : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, getGetUrlPart: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getGetUrlPart : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, getGetListUrlPart: {
		value: function () {
			throw new Error("FwMC.Storage.DaoRemote.getGetListUrlPart : fonction à implémenter")
		}, writable: !1, enumerable: !0
	}, setAjaxParams: function (a) {
		var b = this.ajaxParams.dataType;
		this.ajaxParams = a, a.dataType || (this.ajaxParams.dataType = b)
	}, getAjaxParams: function () {
		return this.ajaxParams
	}, _makeReponse: function (a, b, c) {
		if (FwMC.Core._Debug.log("DaoRemote - _makeReponse - code " + a + "(" + c.returnCode + ")"), c.headers.get("Content-Type") && void 0 != c.headers.get("Content-Type")) {
			var d = c.headers["Content-Type"];
			"application/json" === d && (c.data = FwMC.Core.Json.parse(c.originalData))
		}
		return 0 == a ? {code: c.returnCode, ref: b, headers: c.headers, result: c.data} : {
			code: c.returnCode,
			ref: b,
			headers: c.headers,
			message: c.message
		}
	}, doInsert: {
		value: function (a, b) {
			FwMC.Core._Debug.log("DaoRemote - doInsert");
			var c = this, d = $.extend(!0, {}, this.ajaxParams);
			b && (a[this.getPrimaryKey()] = null);
			var e = a[this.getPrimaryKey()];
			d.requestType = "POST";
			var f = this.uri;
			"" != e && null != e && (d.requestType = "PUT", f = this.uri + this.getInsertUrlPart(e)), FwMC.Core._Debug.log("DaoRemote - doInsert - format : " + d.dataType);
			var g = this._buildParams(a, this.getNaturalKey());
			d.params = g;
			var h = Q.defer();
			return FwMC.Core.doAjaxAsync(f, d).then(function (b) {
				if ("" != b.headers.Location && null != b.headers.Location) {
					var d = c.getIdFromLocation(b.headers.Location);
					FwMC.Core._Debug.log("DaoRemote - doInsert - identifiant de la ressource créée : " + d), a[c.getPrimaryKey()] = d
				}
				b.returnCode > 399 ? h.reject(c._makeReponse(0, a, b)) : h.resolve(c._makeReponse(0, a, b))
			}, function (b) {
				h.reject(c._makeReponse(-1, a, b))
			}).done(), h.promise
		}, writable: !1, enumerable: !0
	}, doUpdate: {
		value: function (a) {
			FwMC.Core._Debug.log("DaoRemote - doUpdate");
			var b = this, c = $.extend(!0, {}, this.ajaxParams);
			c.requestType = "PUT";
			var d = a[this.getPrimaryKey()];
			FwMC.Core._Debug.log("DaoRemote - doUpdate - id : " + d), FwMC.Core._Debug.log("DaoRemote - doUpdate - format : " + c.dataType);
			var e = this.uri + this.getUpdateUrlPart(d);
			FwMC.Core._Debug.log("DaoRemote - doUpdate - url : " + e);
			var f = this._buildParams(a, this.getNaturalKey());
			c.params = f;
			var g = Q.defer();
			return FwMC.Core.doAjaxAsync(e, c).then(function (c) {
				c.returnCode > 399 ? g.reject(b._makeReponse(0, a, c)) : g.resolve(b._makeReponse(0, a, c))
			}, function (c) {
				g.reject(b._makeReponse(-1, a, c))
			}).done(), g.promise
		}, writable: !1, enumerable: !0
	}, doDelete: {
		value: function (a) {
			FwMC.Core._Debug.log("DaoRemote - doDelete");
			var b = this, c = $.extend(!0, {}, this.ajaxParams);
			c.requestType = "DELETE";
			var d = a[this.getPrimaryKey()];
			FwMC.Core._Debug.log("DaoRemote - doDelete - id : " + d), FwMC.Core._Debug.log("DaoRemote - doDelete - format : " + c.dataType);
			var e = this.uri + this.getDeleteUrlPart(d);
			FwMC.Core._Debug.log("DaoRemote - doDelete - url : " + e);
			var f = this._buildParams(a, this.getNaturalKey());
			c.params = f;
			var g = Q.defer();
			return FwMC.Core.doAjaxAsync(e, c).then(function (c) {
				c.returnCode > 399 ? g.reject(b._makeReponse(0, a, c)) : g.resolve(b._makeReponse(0, a, c))
			}, function (c) {
				g.reject(b._makeReponse(-1, a, c))
			}).done(), g.promise
		}, writable: !1, enumerable: !0
	}, doGet: {
		value: function (a) {
			FwMC.Core._Debug.log("DaoRemote - doGet");
			var b = this, c = $.extend(!0, {}, this.ajaxParams);
			c.requestType = "GET";
			var d = a[this.getPrimaryKey()];
			FwMC.Core._Debug.log("DaoRemote - doGet - id : " + d), FwMC.Core._Debug.log("DaoRemote - doGet - format : " + c.dataType);
			var e = this.uri + this.getGetUrlPart(d);
			FwMC.Core._Debug.log("DaoRemote - doGet - url : " + e);
			var f = Q.defer();
			return FwMC.Core.doAjaxAsync(e, c).then(function (c) {
				c.returnCode > 399 ? f.reject(b._makeReponse(0, a, c)) : f.resolve(b._makeReponse(0, a, c))
			}, function (c) {
				f.reject(b._makeReponse(-1, a, c))
			}).done(), f.promise
		}, writable: !1, enumerable: !0
	}, doGetList: {
		value: function (a, b, c, d) {
			FwMC.Core._Debug.log("DaoRemote - doGetList");
			var e = this, f = $.extend(!0, {}, this.ajaxParams);
			f.requestType = "GET", FwMC.Core._Debug.log("DaoRemote - doGetList - format : " + f.dataType);
			var g = this.uri + this.getGetListUrlPart(b, c);
			d && (g = this._addUrlParameter(g, d)), FwMC.Core._Debug.log("DaoRemote - doGetList - url : " + g);
			var h = Q.defer();
			return FwMC.Core.doAjaxAsync(g, f).then(function (b) {
				b.returnCode > 399 ? h.reject(e._makeReponse(0, a, b)) : h.resolve(e._makeReponse(0, a, b))
			}, function (b) {
				h.reject(e._makeReponse(-1, a, b))
			}).done(), h.promise
		}, writable: !1, enumerable: !0
	}, _addUrlParameter: function (a, b, c) {
		var d = a, e = b;
		void 0 !== c && (e = b + "=" + c);
		var f = a.indexOf("?");
		return d = -1 == f ? d + "?" + e : d + "&" + e
	}, _buildParams: function (a, b) {
		var c = a.toDTODistant();
		if (b) {
			for (var d = "", e = 0; e < b.length; e++) b[e] && (e > 0 && (d += ","), d += b[e]);
			c.naturalKey = d
		}
		return c
	}
});
FwMC.Storage.DaoRest = FwMC.Storage.DaoRemote.extend({
	constructor: function (a, b) {
		FwMC.Storage.DaoRest._super.constructor.call(this, a, b)
	}, getIdFromLocation: function (a) {
		var b, c = a.indexOf("id=");
		return c > 0 ? b = a.substring(c + 3) : (FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : attention, la location n'a pas le bon format !"), FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : attendu : urlserveur/maresource.ea?id=xxxx"), FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : reçu : " + a)), b
	}, getInsertUrlPart: function (a) {
		return "?id=" + a
	}, getUpdateUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getDeleteUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getGetUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getGetListUrlPart: function (a, b) {
		var c = "";
		if (null != a) {
			var d = "";
			if (Array.isArray(a)) for (var e = 0; e < a.length; e++) a[e] && b[e] && (e > 0 && (d += ","), void 0 === b ? d += a[e] : d = d + a[e] + ":" + b[e]); else d = void 0 === b ? a : a + ":" + b;
			c = "?filter=" + d
		}
		return c
	}
});
FwMC.Storage.DaoRestFul = FwMC.Storage.DaoRemote.extend({
	constructor: function (a, b) {
		FwMC.Storage.DaoRestFul._super.constructor.call(this, a, b)
	}, getIdFromLocation: function (a) {
		var b, c = a.lastIndexOf("/");
		return c > 0 ? b = a.substring(c + 1) : (FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : attention, la location n'a pas le bon format !"), FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : attendu : urlserveur/maresource/xxxx"), FwMC.Core._Debug.log("FwMC.Storage.DaoRest.getIdFromLocation : reçu : " + a)), b
	}, getInsertUrlPart: function (a) {
		return "/" + a
	}, getUpdateUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getDeleteUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getGetUrlPart: function (a) {
		return this.getInsertUrlPart(a)
	}, getGetListUrlPart: function (a, b) {
		var c = "s";
		if (null != a) {
			var d = "";
			if (Array.isArray(a)) for (var e = 0; e < a.length; e++) a[e] && b[e] && (e > 0 && (d += "&"), void 0 === b ? d += a[e] : d = d + a[e] + "=" + b[e]); else d = void 0 === b ? a : a + "=" + b;
			c = "?" + d
		}
		return c
	}
});
FwMC.Storage.LocalDaoFactory = {
	_getDao: function (a) {
		var b = new FwMC.Storage._DaoIndexedDB(a.store, a.resourceId);
		return b.setPrimaryKey(a.getPrimaryKey()), b.setNaturalKey(a.getNaturalKey()), b
	}
}, FwMC.Storage.RemoteDaoFactory = {
	mapDaoForResource: new Object,
	_DefaultRemoteDao: FwMC.Storage.DaoRest,
	setDefaultRemoteDao: function (a) {
		this._DefaultRemoteDao = a
	},
	useDaoForResource: function (a, b) {
		if (!a) throw new Error("FwMC.Storage.RemoteDaoFactory.useDaoForResource : remoteDao est obligatoire !");
		if (!b) throw new Error("FwMC.Storage.RemoteDaoFactory.useDaoForResource : descriptor est obligatoire !");
		var c = new a(b.uri, b.resourceId);
		this._checkRemoteDao(c), this.mapDaoForResource[b.resourceId] = c
	},
	_checkRemoteDao: function (a) {
		if (!(a instanceof FwMC.Storage.DaoRemote)) throw new Error("FwMC.Storage.RemoteDaoFactory._checkRemoteDao : remoteDao n'étend pas FwMC.Storage.DaoRemote !");
		try {
			a.getIdFromLocation(""), a.getInsertUrlPart(""), a.getUpdateUrlPart(""), a.getDeleteUrlPart(""), a.getGetUrlPart(""), a.getGetListUrlPart(null)
		} catch (b) {
			throw new Error("FwMC.Storage.RemoteDaoFactory._checkRemoteDao : remoteDao n'est pas correctement définit ! " + b)
		}
	},
	_getDao: function (a) {
		var b = null;
		return this.mapDaoForResource[a.resourceId] ? (b = this.mapDaoForResource[a.resourceId], b.setPrimaryKey(a.getPrimaryKey()), b.setNaturalKey(a.getNaturalKey()), b.setAjaxParams(a.getAjaxParams())) : (b = new this._DefaultRemoteDao(a.uri, a.resourceId), b.setPrimaryKey(a.getPrimaryKey()), b.setNaturalKey(a.getNaturalKey()), b.setAjaxParams(a.getAjaxParams()), this.mapDaoForResource[a.resourceId] = b), b
	}
};
