(function() {
	
	var regExp = /.json/;
	
	function parseData(res) {
		if(typeof res.data === "string") {
			try {
				res.data = FwMC.Core.Json.parse(res.originalData);
			} catch(e) {
				// On ne veut pas que ca plante...
			}
		}
	}
	
	// Surcharge Ajax synchrone
	var _doAjaxSync = FwMC.Core.doAjaxSync;
	
	FwMC.Core.doAjaxSync = function(url) {
		var res = _doAjaxSync.apply(this, arguments);
		
		if(url.match(regExp) && res !== undefined) {
			parseData(res);
		}
		
		return res;
	};
	
	
	// Surcharge Ajax asynchrone
	var _doAjaxAsync = FwMC.Core.doAjaxAsync;
	
	FwMC.Core.doAjaxAsync = function(url) {
		var deferred = Q.defer();
		
		_doAjaxAsync.apply(this, arguments)
			.then(function(res) {
				if(url.match(regExp) && res !== undefined) {
					parseData(res);
				}
				
				deferred.resolve(res);
			},
			function(err) {
				deferred.reject(err);
			});
		
		return deferred.promise;
	};
	
}());